// GITVERSION: texstuff-1.4.0-67-ge52a7899
#ifndef EVAL_HPP
#define EVAL_HPP
#include "aedtools/evalbase.hpp"
#include <forward_list>
#include <sstream>
#include <algorithm>
using namespace std;

namespace aed {

  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
  //   FUNCTIONS FOR THIS EXAM
  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>

  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
  // END FUNCTIONS FOR THIS EXAM
  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>

  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*> ISINVERSE
#undef EJERC
#undef EVAL
#define EJERC 1
#define EVAL eval1_t
  typedef bool (*isinverse_t)(vector<int> &p1,vector<int> &p2);
  class EVAL : public eval_base_t {
  public:
    isinverse_t F;
    EVAL() { dumptests=0; F=NULL; ejerc=EJERC; testfile="./ap.json"; }
    void run_case(json &data,json &outuser) {
      vector<int> p = data["p"];
      vector<int> q = data["q"];
      outuser["retval"] = F(p,q);
    }

    int check_case(json &datain,
                   json &outref,json &outuser) {
      return outref==outuser;
    }

    void generate_case(randomg_t &rnd,json &datain) {
      int n=rnd.rand()%3+3;
      vector<int> p(n),q(n);
      for (int j=0; j<n; j++) p[j]=j;
      random_shuffle(rnd,p);
      if (rnd.rand()%2) {
        // Choose another random perm
        q=p; random_shuffle(rnd,q);
      } else {
        // Set the inverse
        for (int j=0; j<n; j++) q[p[j]]=j;
      }
      datain["p"] = p;
      datain["q"] = q;
    }
  };

  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*> MKMONOTONE
#undef EJERC
#undef EVAL
#define EJERC 2
#define EVAL eval2_t
  typedef void (*mkmonotone_t)(vector<int> &v,vector< vector<int> > &vv);
  class EVAL : public eval_base_t {
  public:
    mkmonotone_t F;
    EVAL() { dumptests=0; F=NULL; ejerc=EJERC; testfile="./mmo.json"; }
    void run_case(json &data,json &outuser) {
      vector<int> v = data["v"];
      vector<vector<int>> vv;
      F(v,vv);
      json jvv = json::array();
      for (auto &v : vv) jvv.push_back(json(v));
      outuser["vv"] = jvv;
    }

    int check_case(json &datain,
                   json &outref,json &outuser) {
      return outref==outuser;
    }

    void generate_case(randomg_t &rnd,json &datain) {
      int n=rnd.rand()%7+7;
      vector<int> v(n);
      for (int j=0; j<n; j++) v[j]=rnd.rand()%10;
      datain["v"] = v;
    }
  };

  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*> MKMONOTONE
#undef EJERC
#undef EVAL
#define EJERC 3
#define EVAL eval3_t
  
  typedef bool (*incluido_t)(vector<int> &v1,vector<int> &v2);
  class EVAL : public eval_base_t {
  public:
    incluido_t F;
    EVAL() { dumptests=0; F=NULL; ejerc=EJERC; testfile="./in.json"; }
    void run_case(json &data,json &outuser) {
      vector<int> v1 = data["v1"];
      vector<int> v2 = data["v2"];
      bool ret = F(v1,v2);
      outuser = json(ret);
    }

    int check_case(json &datain,
                   json &outref,json &outuser) {
      return outref==outuser;
    }

    void generate_case(randomg_t &rnd,json &datain) {
      int n=rnd.rand()%7+7;
      vector<int> v1(n),v2;
      for (int j=0; j<n; j++) v1[j]=rnd.rand()%10;
      int n2=n/2;
      int j1=rnd.rand()%n2;
      int j2=n2+rnd.rand()%n2;
      for (int j=j1; j<j2; j++) v2.push_back(v1[j]);
      if (rnd.rand()%2) v2.push_back(rnd.rand()%10);
      datain["v1"] = v1;
      datain["v2"] = v2;
    }
  };

  
  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
  using Eval = eval_t<eval1_t,isinverse_t,
                      eval2_t,mkmonotone_t,
                      eval3_t,incluido_t>;
}

#undef CSTR

#endif
