// GITVERSION: texstuff-1.4.0-759-g438d960f
#ifndef EVAL_HPP
#define EVAL_HPP
#include "aedtools/evalbase.hpp"
#include <forward_list>
#include <sstream>
#include <algorithm>
#include <Eigen/Dense>

using namespace std;
using namespace Eigen;

#define ESHV(x) cout << #x << endl << x << endl

set<int> intsermax(vector<set<int>> &VS,set<int> &Q);
void flatten(json &nested,json &flat);
double maxvol(MatrixXd &xnodes);

namespace aed {

  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
  //   FUNCTIONS FOR THIS EXAM
  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>

  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
  // END FUNCTIONS FOR THIS EXAM
  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>

  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*> INTSERMAX
#undef EJERC
#undef EVAL
#define EJERC 1
#define EVAL eval1_t
  
  class EVAL : public eval_base_t {
  public:
    EVAL() { dumptests=0; ejerc=EJERC; testfile="./intsermax.json"; }
    void run_case(json &data,json &outuser) {
      vector<set<int>> VS;
      for (auto &s : data["VS"]) {
        set<int> tmp = s;
        VS.push_back(tmp);
      }
      set<int> Q = data["Q"];
      set<int> Smax = intsermax(VS,Q);
      outuser["Smax"] = Smax;
    }

    int check_case(json &datain,
                   json &outref,json &outuser) {
      return outref==outuser;
    }

    void generate_case(randomg_t &rnd,json &datain) {
      int nset=3+rnd.rand()%4;
      json VS;
      for (int j=0; j<nset; j++) {
        int m=3+rnd.rand()%4;
        set<int> S;
        for (int j=0; j<m; j++) S.insert(rnd.rand()%9);
        VS.push_back(json(S));
      }
      int m=3+rnd.rand()%4;
      set<int> Q;
      for (int j=0; j<m; j++) Q.insert(rnd.rand()%9);
      datain.clear();
      datain["VS"].swap(VS);
      json JQ=Q;
      datain["Q"].swap(JQ);
    }
  };

  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*> FLATTEN
#undef EJERC
#undef EVAL
#define EJERC 2
#define EVAL eval2_t
  
  class EVAL : public eval_base_t {
  public:
    json items;
    EVAL() { dumptests=0; ejerc=EJERC; testfile="./flatten.json";
      items = json::parse(R"|(["Tokio",2,"Paris","dog",null,23,"pi",3.14,8])|");
    }
    void run_case(json &data,json &outuser) {
      flatten(data,outuser);
    }

    int check_case(json &datain,
                   json &outref,json &outuser) {
      return outref==outuser;
    }

    json mkjson(randomg_t &rnd,int depth) {
      int nitems=items.size();
      json retval;
      if (rnd.rand()%depth==0) 
        retval = items[rnd.rand()%nitems];
      else {
        int m=rnd.rand()%5;
        for (int j=0; j<m; j++) 
          retval.push_back(mkjson(rnd,depth-1));
      }
      return retval;
    }
    void generate_case(randomg_t &rnd,json &datain) {
      datain = mkjson(rnd,5);
    }
  };

  //---:---<*>---:---<*>---:---<*>---:---<*>---:---<*> FLATTEN
#undef EJERC
#undef EVAL
#define EJERC 3
#define EVAL eval3_t
  
  class EVAL : public eval_base_t {
  public:
    EVAL() { dumptests=0; ejerc=EJERC; testfile="./maxvol.json"; }
    void run_case(json &data,json &outuser) {
      vector<double> x = data["xnodes"];
      int ndim=3;
      assert(x.size()%ndim==0);
      int nnod=x.size()/ndim;
      MatrixXd xnodes(nnod,ndim);
      for (int j=0; j<nnod; j++) 
        for (int l=0; l<ndim; l++) 
          xnodes(j,l) = x[j*ndim+l];
      outuser["retval"] = maxvol(xnodes);
      
    }

    int check_case(json &datain,
                   json &outref,json &outuser) {
      double maxvolref = outref["retval"].get<double>();
      double maxvoluser = outuser["retval"].get<double>();
      return fabs(maxvoluser-maxvolref)<1e-8;
    }

    void generate_case(randomg_t &rnd,json &datain) {
      int nx=(4+rnd.rand()%9)*3;
      json x;
      for (int j=0; j<nx; j++) x.push_back(rnd.rand()%4);
      datain["xnodes"].swap(x);
      cout << datain << endl;
    }
  };
  
}

#undef CSTR

#endif
